/****************************************************************
 * hu.c
 * Last change 10-24-2014 by Osman Celimli
 ****************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "bytes.h"
#include "hu.h"
/****************************************************************
 * HuAddress hu_calcAddr(unsigned int uiAddr)
 * Convert a normal, flat address to a banked & mapped HuAddress.
 ****************************************************************/
HuAddress hu_calcAddr(unsigned int uiAddr)
{
	HuAddress huAddr;
	int8p8_t baseAddr;
	unsigned int uiBaseBank,uiBaseMap;

	baseAddr.usWhole = uiAddr % HU_BANKSIZE;
	uiBaseBank = uiAddr / HU_BANKSIZE;
	uiBaseMap = 0;

	while((HU_MAPBANKS - 1) < uiBaseBank)
	{
		uiBaseMap++;
		uiBaseBank -= HU_MAPBANKS;
	}

	huAddr.ucLow = baseAddr.ucPair.ucLo;
	huAddr.ucHigh = baseAddr.ucPair.ucHi;
	huAddr.ucBank = uiBaseBank;
	huAddr.ucMap = uiBaseMap;

	return huAddr;
}
